#!/usr/bin/env python
# -*- coding: utf-8 -*-
##~---------------------------------------------------------------------------##
##                        _      _                 _   _                      ##
##                    ___| |_ __| |_ __ ___   __ _| |_| |_                    ##
##                   / __| __/ _` | '_ ` _ \ / _` | __| __|                   ##
##                   \__ \ || (_| | | | | | | (_| | |_| |_                    ##
##                   |___/\__\__,_|_| |_| |_|\__,_|\__|\__|                   ##
##                                                                            ##
##  File      : main.py                                                       ##
##  Project   : ytmd                                                          ##
##  Date      : Feb 03, 2019                                                  ##
##  License   : GPLv3                                                         ##
##  Author    : stdmatt <stdmatt@pixelwizards.io>                             ##
##  Copyright : stdmatt - 2019                                                ##
##                                                                            ##
##  Description :                                                             ##
##    Downloads a single album video from youtube and splits its tracks       ##
##    to separated .mp3 files.                                                ##
##                                                                            ##
##    This way we can have a standard music album easily!                     ##
##                                                                            ##
##    All the hard work is done by the amazing youtube-dl and ffmpeg!         ##
##    This is just a wrapper with some fancy stuff ;D                         ##
##---------------------------------------------------------------------------~##


##----------------------------------------------------------------------------##
## Imports                                                                    ##
##----------------------------------------------------------------------------##
import sys;
import subprocess;
import youtube_dl;
import pdb;
import os;
import os.path;
import time;
import shutil;
import sys;
import getopt;


##----------------------------------------------------------------------------##
## Constants                                                                  ##
##----------------------------------------------------------------------------##
VERSION_MAJOR = 0;
VERSION_MINOR = 0;
VERSION_BABY  = 1;

CMD_SPLIT_FMT="ffmpeg -i \"{BIG_FILE}\" -acodec copy -ss {START_TIME} -to {END_TIME} \"{LITTLE_FILE}\"";
URL_WATCH_STR="watch?v=";
TIMESTAMP_LONG_ENOUGH_TO_BE_THE_LAST_TRACK = "99:59:59";


##----------------------------------------------------------------------------##
## Functions                                                                  ##
##----------------------------------------------------------------------------##
##------------------------------------------------------------------------------
def help():
    pass;

##------------------------------------------------------------------------------
def version():
    pass;

##------------------------------------------------------------------------------
def get_version_string():
    return "{0}.{1}.{2}".format(VERSION_MAJOR, VERSION_MINOR, VERSION_BABY);

##------------------------------------------------------------------------------
def fatal(*msg):
    print "[FATAL]", " ".join(msg);
    exit(1);

##------------------------------------------------------------------------------
def execute(cmd_str):
    result = subprocess.check_output(
        cmd_str,
        stderr = subprocess.STDOUT,
        shell  = True
    );
    return result;


##------------------------------------------------------------------------------
## @brief
##    Splits the .mp3 file that was generated by the youtube-dl into
##    smaller .mp3 files with the individual track.
##
## @param original_filename
##    The original .mp3 file that's gonna be split.
## @param start_time
##    String in the format of HH::MM::SS of the start of the track within
##    the original .mp3 file.
## @param end_time
##    String in the format of: HH::MM::SS of the end of the track within
##    the original .mp3 file.
## @param output_filename :
##    The name of this song, it can be prepended with a folder name , if so
##    the output file will be placed on that directory.
def split_track(original_filename, start_time, end_time, output_filename):
    ## @todo(stdmatt): Check errors.
    ## @todo(stdmatt): Make the output respect the target folder...
    cmd_str = CMD_SPLIT_FMT.format(
        BIG_FILE    = original_filename,
        START_TIME  = start_time,
        END_TIME    = end_time,
        LITTLE_FILE = output_filename
    );

    execute(cmd_str);

##------------------------------------------------------------------------------
## @brief
##    Gets the clean album name and the downloaded video/thumbnail filename.
##
## @param video_url
##    The url that was used to download the album .mp3 file with youtube-dl.
## @returns
##    The album name and the downloaded video/thumbnail filename ;D
## @see URL_WATCH_STR
def find_album_name(video_url):
    ## @todo(stdmatt): Check errors...
    ## @todo(stdmatt): Handle the case that we can't find the names...

    ## @notice(stdmatt): The heuristic to discover the album name.
    ## Since the youtube-dl downloads the album file and make the url used
    ## to download as a suffix, we just try to list the files on the directory
    ## and search for a filename that contains that url.
    ## If we found something like that we assume that it's our file.
    watch_str_index = video_url.index(URL_WATCH_STR);
    video_hash_str  = video_url[watch_str_index + len(URL_WATCH_STR):];

    video_filename     = None;
    thumbnail_filename = None;

    for filename in os.listdir("."):
        if(filename.count(video_hash_str) and filename.endswith(".jpg")):
            thumbnail_filename = filename;
            continue;

        if(filename.count(video_hash_str) and filename.endswith(".mp3")):
            video_filename = filename;
            continue;

    album_name = video_filename[:len(video_filename) - (len(video_hash_str + ".mp3") + 1)];
    return album_name, video_filename, thumbnail_filename;

##------------------------------------------------------------------------------
## @brief Just makes a directory with the album name.
## @param album_name - The name of the album.
## @returns The absolute path for the album_folder.
def make_album_folder(album_name):
    album_name = album_name.replace(" ", "_");
    try:
        os.mkdir(album_name);
    except Exception as e:
        pass;

    return os.path.abspath(album_name);

##------------------------------------------------------------------------------
## @brief
##   Reads and makes a dictionary with the tracks information from the file.
## @param filename - The tracks info file name.
## @returns The dictionary with the info of all tracks of the album.
def read_tracks_info(filename):
    f     = open(filename);
    lines = f.readlines();
    f.close();

    clean_lines = [];
    for line in lines:
        line = line.replace("\n", "").strip(" ");
        if(len(line) != 0):
            clean_lines.append(line);

    tracks_info = [];
    current_timestamp = TIMESTAMP_LONG_ENOUGH_TO_BE_THE_LAST_TRACK;

    for i in xrange(len(clean_lines) -1, -1, -1):
        line = clean_lines[i];
        timestamp, name = line.split("||"); ## todo(stdmatt): Find a better separator.

        tracks_info.append({
            "index" : i,
            "start" : timestamp,
            "end"   : current_timestamp,
            "name"  : name
        });
        current_timestamp = timestamp;

    return tracks_info;

##------------------------------------------------------------------------------
## @brief Builds the final filename for the track, including the folder path.
## @param album_path  - The folder path for that track.
## @param track_index - The index of that track in the album.
## @param track_name  - The name of the track itself.
## @returns A complete filepath for that track in the format of:
##    album/folder/path/{Index}-{Name}.mp3
def build_output_track_filename(album_path, track_index, track_name):
    clean_track_name = str(track_index + 1) + "-" + track_name + ".mp3";
    return os.path.join(album_path, clean_track_name);

##------------------------------------------------------------------------------
def make_album_info_file(album_path, album_name, tracks_info, video_url):
    f = open(os.path.join(album_path, "info.txt"), "w");

    f.write("Album: {0}\n".format(album_name));
    f.write("URL: {0}\n".format(video_url));
    f.write("Tracks: \n");
    for info in reversed(tracks_info):
        f.write("   {0} - {1}\n".format(info["index"], info["name"]));

    f.write("\n");
    f.write("Download date: {0}\n".format(time.ctime(time.time())));
    f.write("ytmd version: {0}\n".format(get_version_string()));

    f.write("\n");
    f.write("Enjoy your music! - ytmd - stdmatt.com - made with <3");
    f.close();


##------------------------------------------------------------------------------
## @brief Copies the thumbnail image that youtube-dl generated for the album.
## @param album_path
##   The folder that the thumbnail will be copied.
## @param thumbnail_filename
##   The filename of the the thumbnail that was generated by youtube-dl
def make_album_thumbnail_file(album_path, thumbnail_filename):
    shutil.copyfile(
        thumbnail_filename,
        os.path.join(album_path, "cover.jpg")
    );

##------------------------------------------------------------------------------
## @brief Remove a file from the filesystem.
## @param filename - The name of the file that will be removed.
def delete_file(filename):
    os.remove(filename);

##------------------------------------------------------------------------------
def my_hook(d):
    if d['status'] == 'finished':
        print('Done downloading, now converting ...')

##------------------------------------------------------------------------------
## @brief Download the album from youtube using youtube-dl
## @param video_url - The url of the album that will be downloaded.
def download_album(video_url):
    ## @improve(stdmatt): Today we're converting first to mp3 then spliting.
    ## If we could split / convert at the same time would be much more quicker.
    ydl_opts = {
        'format': 'bestaudio/best',
        'postprocessors': [{
            'key': 'FFmpegExtractAudio',
            'preferredcodec': 'mp3',
            'preferredquality': '192',
        }],
        'progress_hooks': [my_hook],
        "writethumbnail" : True,
    }

    print "DOWNLOADING:", video_url;
    with youtube_dl.YoutubeDL(ydl_opts) as ydl:
        ydl.download([video_url]);

##------------------------------------------------------------------------------
## @brief
##   Downloads the album from youtube, split it's tracks, create the thumbnail
##   and all the goodies that this program is supposed to do.
## @param video_url       - The youtube url for the album.
## @param tracks_filename - The filename with information about the tracks.
def download(video_url, tracks_filename):
    ## @todo(stdmatt): Check if we have a valid url.
    ## @todo(stdmatt): Check if we have a valid tracks file.

    ##
    ## Calls youtube-dl to download the album and convert to .mp3
    download_album(video_url);

    album_name, video_filename, thumbnail_filename = find_album_name(video_url);
    album_folder_path = make_album_folder(album_name);
    tracks_info       = read_tracks_info (tracks_filename);

    ##
    ## Split all the tracks from the downloaded .mp3.
    for track_info in tracks_info:
        print track_info;
        track_file_path = build_output_track_filename(
            album_folder_path,
            track_info["index"],
            track_info["name"]
        );

        split_track(
            video_filename,
            track_info["start"],
            track_info["end"],
            track_file_path
        );

    ##
    ## Make the info and cover files.
    make_album_thumbnail_file(album_folder_path, thumbnail_filename);
    make_album_info_file     (album_folder_path, album_name, tracks_info, video_url);

    ##
    ## Delete the downloaded stuff...
    delete_file(video_filename);
    delete_file(thumbnail_filename);


##----------------------------------------------------------------------------##
## Script                                                                     ##
##----------------------------------------------------------------------------##
def main():
    ##
    ## Parse the command line arguments...
    try:
        opts, args = getopt.gnu_getopt(
            sys.argv[1:],
            "hvu:t:",
            ["help", "version", "url=", "tracks="]
        );
    except getopt.GetoptError as err:
        fatal(str(err));

    ##
    ## Get the command line arguments.
    video_url   = None;
    tracks_file = None;

    for o, a in opts:
        if(o in ("-h", "--help"   )): help   ();
        if(o in ("-v", "--version")): version();
        if(o in ("-u", "--url"    )): video_url   = a;
        if(o in ("-t", "--tracks" )): tracks_file = a;

    ##
    ## Check if we have the required arguments.
    if(video_url   is None): fatal("Missing (--url) argument.");
    if(tracks_file is None): fatal("Missing (--tracks) argument.");

    download(video_url, tracks_file);


if __name__ == "__main__":
    main();
